﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EuroManager.Domain.Simulator.Engine;
using EuroManager.Domain.Simulator.World;

namespace EuroManager.Domain.Simulator.Tests
{
    public class FakeRandomizer : IRandomizer
    {
        public Vector2D AutoBallKickVelocity(float minLength, float maxLength)
        {
            float value = (minLength + maxLength) / 2;

            return new Vector2D(value, value);
        }

        public float PlayerAIDecisionDelaySalt(float delay)
        {
            return 0;
        }

        public bool ShouldPassBall(float chance)
        {
            return false;
        }

        public IPlayer PlayerToPassBallTo(IEnumerable<IPlayer> players, float[] chances)
        {
            return players.First();
        }

        public float PlayerReceivePassSpeed(float minSpeed, float maxSpeed)
        {
            return (minSpeed + maxSpeed) / 2;
        }

        public bool ShouldShoot(float chance)
        {
            throw new NotImplementedException();
        }
    }
}
