﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EuroManager.Domain.Simulator.Engine;
using EuroManager.Domain.Simulator.Tactics;
using EuroManager.Domain.Simulator.World;

namespace EuroManager.Domain.Simulator.Tests.Tactics
{
    public class FakePlayerTactics : IPlayerTactics
    {
        private Vector2D location;

        public FakePlayerTactics()
            : this(Vector2D.Zero)
        {
        }

        public FakePlayerTactics(Vector2D location)
        {
            this.location = location;
        }

        public Vector2D CalculateKickOffLocation(IPitch pitch, PitchSide side)
        {
            return location;
        }

        public Vector2D CalculateTacticalLocation(IPitch pitch, PitchSide side, Vector2D ballLocation)
        {
            return location;
        }
    }
}
