﻿using System;
using System.Collections.Generic;
using System.Diagnostics.Contracts;
using System.Linq;
using System.Text;
using EuroManager.Domain.Simulator.Helpers;

namespace EuroManager.Domain.Simulator.Result
{
    public class PlayerData
    {
        private List<float> xs = new List<float>();
        private List<float> ys = new List<float>();
        private List<float> angles = new List<float>();

        public PlayerData(GameTeam team, int number)
        {
            Contract.Requires(number > 0);

            Team = team;
            Number = number;
        }

        public GameTeam Team { get; private set; }

        public int Number { get; private set; }

        public float[] X
        {
            get { return xs.ToArray(); }
        }

        public float[] Y
        {
            get { return ys.ToArray(); }
        }

        public float[] Angle
        {
            get { return angles.ToArray(); }
        }

        public void AddFrame(float x, float y, float angle)
        {
            Contract.Requires(x.IsRational());
            Contract.Requires(y.IsRational());
            Contract.Requires(angle.IsRational());

            xs.Add(x);
            ys.Add(y);
            angles.Add(angle);
        }
    }
}
