﻿using System;
using System.ComponentModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using EuroManager.Presentation.WebPortal.GameViewer.Data;

namespace EuroManager.Presentation.WebPortal.GameViewer.Models
{
    public class Player : PresentationModel
    {
        private float x = 0;
        private float y = 0;
        private float angle = 0;

        public Player(GameTeam team, int number)
        {
            Number = number;

            if (number == 1)
            {
                PlayerType = PlayerType.Goalkeeper;
            }
            else
            {
                PlayerType = team == GameTeam.Team1 ? PlayerType.Team1FieldPlayer : PlayerType.Team2FieldPlayer;
            }
        }

        public PlayerType PlayerType { get; private set; }

        public int Number { get; private set; }

        public float X
        {
            get { return x; }
            set
            {
                if (x != value)
                {
                    x = value;
                    RaisePropertyChanged("X");
                }
            }
        }

        public float Y
        {
            get { return y; }
            set
            {
                if (y != value)
                {
                    y = value;
                    RaisePropertyChanged("Y");
                }
            }
        }

        public float Angle
        {
            get { return angle; }
            set
            {
                if (angle != value)
                {
                    angle = value;
                    RaisePropertyChanged("Angle");
                }
            }
        }
    }
}
